import javax.swing.JFrame;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Dialog.*;
import java.lang.Math.*;


import javax.swing.*;
import javax.swing.table.*;


public class Form3 extends JFrame implements ActionListener
{
	
	   public static final String[] COLHEADS = {
    "Jahr", "Auszahlung"
	  };
	
   private JTable table;
   private double FV;
   private double p;
   private double invest;
	   
	public Form3(double FV,double[] MaxZahlungen,double p, double invest)
	{
		super("JTable 1");
		//addWindowListener(new WindowClosingAdapter(true));
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		String Daten[][] = new String[MaxZahlungen.length][2];
		this.FV=FV;
		this.p=p;
		this.invest=invest;
		double wert=0;
		double gesamt=0;
		int x=0;
		int y=0;
	    
	    for(int i=0;i<MaxZahlungen.length;i++)
	    {
	    	for(int j=0;j<2;j++)
	    	{
	    		switch(j)
	    		{
	    		case 0:
	    		{   
	    			Daten[i][j]=(new Integer(i+1)).toString();
	    			break;

	    		}
	    		case 1:
	    		{
	    			wert=MaxZahlungen[i];
	    			if(gesamt+wert<FV){
	    				Daten[i][j]=(new Double(MaxZahlungen[i])).toString();	    				
	    				gesamt=gesamt+wert;
	    			}
	    			else{
	    				if(x==0){
	    				x=1;
	    				wert=FV-gesamt;
	    				Daten[i][j]=(new Double(wert)).toString();
	    				}
	    				else
	    				{
	    					Daten[i][j]=(new Double(y)).toString();
	    				}
	    			}
	    			break;
	    		}
	    		}
	    	}
	    }
	    table = new JTable(Daten, COLHEADS);
	    //table.addTableModelListener(table.getSelectionModel());
	    Container cp = getContentPane();
	    cp.add(new JLabel("optimale Verteilung der Rckzahlungen:"), BorderLayout.NORTH);
	    cp.add(new JScrollPane(table), BorderLayout.CENTER);
	    
	    
	    JButton Bewerten = new JButton("bewerten");
	    Bewerten.addActionListener(this);
	    getContentPane().add(Bewerten,BorderLayout.SOUTH);
	    
	    this.pack();
	    this.setVisible(true);
		
	}
	
	public void actionPerformed(ActionEvent event)
    {
		double Gesamt=0;
		double barwert=0;
		double kapitalwert=0;
		double val=0;
		int power=0;
		
		
        for(int rows=0;rows<table.getRowCount();rows++)
        {
        	Object wert = table.getValueAt(rows,1);
        	Gesamt=Gesamt+Double.parseDouble((String)wert);
        }
        System.out.println("Gesamt:"+Gesamt);
        if(Gesamt==FV)
        {
        	String fazit;
        	int i=table.getRowCount()-1;
        	int n=table.getRowCount();
        	double q=p/100+1;
        	while(i>=0){
        		power++;
        	//Abzinsen
        		q=p/100+1;
        		power++;
        		Object tmp = table.getValueAt(i,1);
        		power++;
        		val=Double.parseDouble((String)tmp);
        		power++;
        		val=val+barwert;
        		power++;
        		barwert=val/q;
        		power++;
        		i--;
        		power++;
        	}
        	//Kapitalwert bilden
        	kapitalwert=barwert-invest;
        	power++;
        	if(kapitalwert<0){
        		fazit= new String("Der Investition ist abzuraten!");
        	}
        	else{
        		fazit= new String("Die Investition ist empfehlenswert!");
        	}
//        	Ermitteln der Rendite
        	double rendite=barwert/invest;
        	rendite=(rendite-1)*100;
        	String rfazit;
        	
        		String rf=((new Double(rendite)).toString());
            	String rf1=rf.substring(0,rf.indexOf(".")+3);
        		rfazit= new String("Die Rendite betrgt "+rf1+"%.");
        		
        	//Konvertierung der Doubles zu einem String mit zwei Nachkommastellen
        	String bw=((new Double(barwert)).toString());
        	String bw1=bw.substring(0,bw.indexOf(".")+3);
        	String kw=((new Double(kapitalwert)).toString());
        	String kw1=kw.substring(0,kw.indexOf(".")+3);
        	String[] Msg ={"Investsumme: ", (new Double(invest)).toString(), "Barwert: ", bw1, "Kapitalwert: ", kw1, fazit, rfazit};
        	MyMessagesBox msg = new MyMessagesBox(this,"Statusmeldung",Msg,1);
        	msg.setVisible();
        	System.out.println("Anzahl Operationen: "+power);
        	System.out.println("Gre von n: "+n);
        }
        else if(Gesamt<FV) 
        {
        	String[] Msg = {"Die Summe der angegebenen", "Rckzahlungen entspricht nicht ", "dem gegebenen FutureValue", "Die Summe ist zu niedrig"};
        	//Show Errorbox, bitte Werte berprfen.....
        	MyMessagesBox msg = new MyMessagesBox(this,"Fehlermeldung",Msg,1);
        	msg.setVisible();        	
        }
        else if(Gesamt>FV) 
        {
        	String[] Msg = {"Die Summe der angegebenen", "Rckzahlungen entspricht nicht ", "dem gegebenen FutureValue", "Die Summe ist zu hoch"};
        	//Show Errorbox, bitte Werte berprfen.....
        	MyMessagesBox msg = new MyMessagesBox(this,"Fehlermeldung",Msg,1);
        	msg.setVisible();        	
        }
    }
}
