import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class MyMessagesBox extends JDialog implements ActionListener
{ 

	private String[] Nachrichten;
	private int Buttons;
	public final int OK = 1;
	public final int CANCEL = 2;

	 
	public MyMessagesBox(JFrame MyFrame,String title,String[] Nachrichten, int Buttons)
	{
		super(MyFrame);
		setTitle(title);
		setLayout(new BorderLayout());
		setDefaultCloseOperation(JDialog.EXIT_ON_CLOSE);
		this.Nachrichten = new String[Nachrichten.length];
		for(int i=0;i<Nachrichten.length;i++)
		{
			this.Nachrichten[i]=Nachrichten[i];
		}
		this.Buttons=Buttons;
		
	} 
	
	
	public void setVisible()
	{
		JPanel jp = new JPanel();
		JButton OKButton = new JButton("OK");
		OKButton.addActionListener(this);
		
		jp.setLayout(new GridLayout(Nachrichten.length,1));
		for(int i=0;i<Nachrichten.length;i++)
		{
			jp.add(new JLabel(Nachrichten[i]));	
		}
		getContentPane().add(jp,BorderLayout.NORTH);
		if((Buttons & 1 ) == this.OK)
		{
			getContentPane().add(OKButton,BorderLayout.SOUTH);
		}
		else
		{
			getContentPane().add(new JButton("CANCEL"),BorderLayout.SOUTH);
		}
		pack();
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent event)
    {
	   this.dispose();	
    }
    
}
